#ifndef __LISTA__
#define __LISTA__

#include <string>
using namespace std;

#include "NodoT.h"

template<typename TIPO>
class Lista {
 private:
  Nodo<TIPO> *head;

  Nodo<TIPO> *buscarPrev(const TIPO& nitem) const;

 public:
  Lista();
  Lista(Nodo<TIPO> *nhead);
  void setHead(Nodo<TIPO> *nhead);
  Nodo<TIPO> *getHead() const;
  Nodo<TIPO> *buscar(const TIPO& nitem) const;
  void inserir(TIPO& nprop, Nodo<TIPO> *prev);
  void remover(Nodo<TIPO> *prev);

  // Adicionais
  void inserir(TIPO& nprop);
  void remover(const TIPO& nitem);
  int getNumItens() const;
};

#include "Lista.cc"

#endif
